// Modules utilisés
import geometry;
unitsize(1cm);

// Initialisation
currentpen=currentpen+1bp;
pen dore=rgb(204/255,204/255,0);
transform r=reflect((0,0),(0,1));

// La tête
point A=(0,0), B=(-3,-3.5), C=(3,-3.5), D=(-2,-4), e=(2,-4), F=(0,-7.1);
circle c1=circle(A,5), c2=circle(B,5), c3=circle(C,5), c4=circle(F,5);
circle c5=circle(D,6.5), c6=circle(e,6.5);
point T1=intersectionpoints(c1,c4)[0], T2=intersectionpoints(c1,c4)[1];
point J1=intersectionpoints(c1,c5)[1], J2=intersectionpoints(c5,c4)[0];

// Les oreilles
point G1=(-2.5,2), G2=(-8.5,2), G3=(-6.5,2), D1=(2.5,2), D2=(8.5,2), D3=(6.5,2);
circle c7=circle(G1,G2), c8=circle(G3,2.5), c9=circle(D1,D2), c10=circle(D3,2.5);
point O1=intersectionpoints(c1,c7)[1], O2=intersectionpoints(c5,c7)[0];
point O3=intersectionpoints(c1,c8)[1], O4=intersectionpoints(c7,c8)[1];

// Les vibrisses
point M1=(0,-11), M2=(0,-12), M3=(0,-13);
circle c11=circle(D,length(F-D)), c12=circle(e,length(F-e)), c13=circle(A,length(M3-A));
circle c14=circle(M1,4.5), c15=circle(M2,6), c16=circle(M3,7.5);
point P1=intersectionpoints(c11,c14)[0], P2=intersectionpoints(c13,c14)[0];
point P5=intersectionpoints(c11,c15)[0], P6=intersectionpoints(c13,c15)[0];
point P9=intersectionpoints(c11,c16)[0], P10=intersectionpoints(c13,c16)[0];

// Les yeux
point Y1=(-2,0), Y2=(2,0);
circle cy1=circle(Y1,0.7), cy2=circle(Y2,0.7);
point YG11=angpoint(c3,136), YG12=(-2,0.4), YG13=(-3.7,0.5), YG14=(-2.5,-0.7), YG15=angpoint(c3,150.5);
point YG16=intersectionpoints(cy1,circle(YG11,YG12,YG13))[1], YG17=intersectionpoints(cy1,circle(YG11,YG12,YG13))[0];
// Il est inutile de déclarer les points YD11, YD12, ... , YD17 car l'axe des ordonnées est un axe de symétrie de la figure 

arc yga1=arccircle(YG11,YG12,YG13), yga2=arccircle(YG13,YG14,YG15), yga4=arccircle(YG17,YG12,YG16);
path yga3=reverse(arc((pair)C,(pair)YG11,(pair)YG15)), yga5=arc((pair)Y1,(pair)YG16,(pair)YG17);
fill(yga4--yga5--cycle,dore+opacity(0.5));
draw(yga4--yga5--cycle,dore);
filldraw((path)circle(Y1,0.2));
draw(yga1--yga2--yga3);

fill(r*(yga4--yga5--cycle),dore+opacity(0.5));
draw(r*(yga4--yga5--cycle),dore);
filldraw(r*((path)circle(Y1,0.2)));
draw(r*(yga1--yga2--yga3));

// Les rayures
point RG11=angpoint(c2,65), RG12=(-0.5,1.6), RG13=(0,1.9), RG14=(0,2), RG15=(-0.7,1.8), RG16=angpoint(c2,70);
point RG21=angpoint(c2,81), RG22=(-1.5,2.2), RG23=(0,3), RG24=(-2,2.4), RG25=angpoint(c2,90);
point RG31=angpoint(c2,102), RG32=(-3,2.7), RG33=(0,4.2), RG34=(-3,3.4), RG35=angpoint(c2,112);
point RG41=angpoint(c4,143), RG42=(-6,-2.5), RG43=angpoint(c2,146), RG44=(-6,-3.5), RG45=angpoint(c4,152);
point RG51=angpoint(c4,166), RG52=(-6.5,-4.5), RG53=angpoint(c2,165), RG54=(-6.5,-5.5), RG55=angpoint(c4,178);
// Il est inutile de déclarer les points RD11, RD12, ... , RD55 (cf remarque précédente)

arc rg11=arccircle(RG14,RG15,RG16), rg13=reverse(arccircle(RG13,RG12,RG11));
path rg12=arc((pair)B,(pair)RG11,(pair)RG16);
fill(rg11--rg12--rg13--reverse(r*rg13)--reverse(r*rg12)--reverse(r*rg11)--cycle,dore+opacity(0.5));
draw(rg11--rg12--rg13--reverse(r*rg13)--reverse(r*rg12)--reverse(r*rg11)--cycle,dore);

arc rg21=arccircle(RG23,RG24,RG25), rg23=reverse(arccircle(RG23,RG22,RG21));
path rg22=reverse(arc((pair)B,(pair)RG21,(pair)RG25));
fill(rg21--rg22--rg23--cycle,dore+opacity(0.5));
draw(rg21--rg22--rg23--cycle,dore);
fill(r*rg21--r*rg22--r*rg23--cycle,dore+opacity(0.5));
draw(r*rg21--r*rg22--r*rg23--cycle,dore);

arc rg31=arccircle(RG33,RG34,J1), rg34=reverse(arccircle(RG33,RG32,RG31));
path rg32=arc((pair)A,(pair)J1,(pair)RG35), rg33=reverse(arc((pair)B,(pair)RG31,(pair)RG35));
fill(rg31--rg32--rg33--rg34--cycle,dore+opacity(0.5));
draw(rg31--rg32--rg33--rg34--cycle,dore);
fill(r*rg31--r*rg32--r*rg33--r*rg34--cycle,dore+opacity(0.5));
draw(r*rg31--r*rg32--r*rg33--r*rg34--cycle,dore);

arc rg41=reverse(arccircle(RG43,RG42,RG41)), rg42=arccircle(RG43,RG44,RG45);
path rg43=reverse(arc((pair)F,(pair)RG41,(pair)RG45));
fill(rg41--rg42--rg43--cycle,dore+opacity(0.5));
draw(rg41--rg42--rg43--cycle,dore);
fill(r*rg41--r*rg42--r*rg43--cycle,dore+opacity(0.5));
draw(r*rg41--r*rg42--r*rg43--cycle,dore);

arc rg51=reverse(arccircle(RG53,RG52,RG51)), rg52=arccircle(RG53,RG54,RG55);
path rg53=reverse(arc((pair)F,(pair)RG51,(pair)RG55));
fill(rg51--rg52--rg53--cycle,dore+opacity(0.5));
draw(rg51--rg52--rg53--cycle,dore);
fill(r*rg51--r*rg52--r*rg53--cycle,dore+opacity(0.5));
draw(r*rg51--r*rg52--r*rg53--cycle,dore);

// tracé à blanc pour l'ajustement du cadre
currentpen=invisible;

// La tête
draw(c1);
draw(c2);
draw(c3);
draw(arc((pair)F,(pair)T1,(pair)T2));
draw(arc((pair)D,(pair)J1,(pair)J2));
draw(r*arc((pair)D,(pair)J1,(pair)J2));

// Les oreilles
draw(arc((pair)0.5*(G1+G2),(pair)O1,(pair)O2));
draw(arc((pair)G3,(pair)O3,(pair)O4));
draw(r*arc((pair)0.5*(G1+G2),(pair)O1,(pair)O2));
draw(r*arc((pair)G3,(pair)O3,(pair)O4));
		 
// Les vibrisses
draw(arc((pair)M1,(pair)P1,(pair)P2));
draw(r*arc((pair)M1,(pair)P1,(pair)P2));
draw(arc((pair)M2,(pair)P5,(pair)P6));
draw(r*arc((pair)M2,(pair)P5,(pair)P6));
draw(arc((pair)M3,(pair)P9,(pair)P10));
draw(r*arc((pair)M3,(pair)P9,(pair)P10));

// Les points utilisés pour le tracé, repérés par des croix
currentpen=defaultpen+1bp;
marker croix=marker(scale(2)*cross(4));
draw("$A$",A,SE,croix);
draw("$B$",B,E,croix);
draw("$C$",C,W,croix);
draw("$D$",D,E,croix);
draw("$E$",e,W,croix);
draw("$F$",F,N,croix);
draw("$D_1$",D1,NE,croix);
draw("$D_2$",D2,NW,croix);
draw("$D_3$",D3,N,croix);
draw("$G_1$",G1,NW,croix);
draw("$G_2$",G2,NE,croix);
draw("$G_3$",G3,N,croix);
draw("$M_1$",M1,N,croix);
draw("$M_2$",M2,N,croix);
draw("$M_3$",M3,N,croix);

shipout(prefix="PatronTigre",bbox(5mm,nullpen),"pdf");
